#!/bin/sh

PATH=/sbin:/bin:/usr/bin:/usr/sbin
TMPDIR=/mnt/ramdisk
LOGFILE_TAR_GZ=${TMPDIR}/logtracker.tar.gz
VERSIONFILE=../pkgVersion.xml
VERSION=`/usr/bin/tinyxmlparser -x /tracker/version -f ${VERSIONFILE}`

Create_Backup_File()
{
    cd ../ || return

	[ -e "/mnt/ramdisk/Metadata.log" ] && metadataLog="/mnt/ramdisk/Metadata.log"
	[ -e "/mnt/ramdisk/TRACKER.log" ] && trackerLog="/mnt/ramdisk/TRACKER.log"
	[ -e "/mnt/flash2/logs/" ] && flash2Log="/mnt/flash2/logs/"
	[ -e "/mnt/flash2/trackerdb/" ] && dbLog="/mnt/flash2/trackerdb/"
	[ -e "/mnt/ramdisk/logs/" ] && ramdiskLog="/mnt/ramdisk/logs/"

	tar zcf "${LOGFILE_TAR_GZ}" "${metadataLog}" "${trackerLog}" "${flash2Log}" "${dbLog}" "${ramdiskLog}"
	strlog="$(wc -c ${LOGFILE_TAR_GZ} | awk '{print $1}')"
    return 0   
}

if [ "$1" = "backup" ]
then
        Create_Backup_File
        [ $? -eq 0 ] && {
			echo -ne "Content-type: text/plain\r\n"
			echo -ne "Content-Disposition: attachment; filename=logtracker-${VERSION}.tar.gz\r\n"
			echo -ne "Content-length:${strlog}\r\n\r\n"
			cat $LOGFILE_TAR_GZ>&1
			rm -rf $LOGFILE_TAR_GZ
		}
fi
