#!/bin/sh
echo -ne "Content-type:text/plain\r\n"
echo -ne "\r\n" # end of HTTP header

if [ "$REQUEST_METHOD" == "POST" ]; then
	echo -ne "HTTP 501"
	exit 0
else
  strparam=$QUERY_STRING
fi

if [ "${strparam}" == "" ]; then
	echo -ne "HTTP 403"
	exit 0
fi

strparam=`/usr/bin/decode.sh $strparam`
#echo ${strparam}
#EVENT=`echo "$strparam" | sed -n 's/^\([^&]*\).*$/\1/p' | sed "s/%20/ /g"`
OIFS="$IFS"
IFS="${IFS}&"
set ${QUERY_STRING}
Args="$*"
IFS="$OIFS"

for i in ${Args}
do
	key=`echo ${i} | cut -d '=' -f1`
	param=`echo ${i} | cut -d '=' -f2`
	case "${key}" in
		"getPkgVer")
			PKG_VER=`grep "<version>" ../vadp.xml | sed 's/.*<version>\(.*\)<\/version>/\1/'`
			echo -ne "PackageVersion='${PKG_VER}'\n"
			;;
		"getPkgConfVer")
			PKG_CONF_VER=`grep "conf.d" ../pkgVersion.xml | sed 's/.*<conf.d>\(.*\)<\/conf.d>/\1/'`
			echo -ne "PackageConfigVersion='${PKG_CONF_VER}'\n"
			;;
		*)
			echo -ne "HTTP 403"
			;;
	esac
done

exit 0

