#!/bin/sh
PATH=/bin:/sbin:/usr/bin:/usr/sbin

reset_target() 
{
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_name"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_url"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_uri"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_schedule"=0 | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_port"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_usr"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_pwd"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_sender"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_recipient"="" | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_sslmode"=0 | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_aggregation"=0 | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_lite"=0 | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_localtime"=0 | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_format"=xml | sed 's/=/="/g;s/$/"/g'`
	echo `confclient -p 99 -s "reportpush_protocol_i${1}_status"=unset | sed 's/=/="/g;s/$/"/g'`
}


if [ $REQUEST_METHOD = POST ]; then
        strparam=`cat $stdin | cut -c1-$CONTENT_LENGTH`
else
        strparam=$QUERY_STRING
fi
#strparam=`decode.sh $strparam`

DEMO_DIR="/mnt/flash2/reportpush"
TARGET=-1

#=================#
#===  PARSING  ===#
#=================#
OIFS="$IFS"
IFS="${IFS}&"
set ${strparam}
Args="$*"
IFS="$OIFS"

echo -ne "Content-type:text/plain\r\n"
echo -ne "\r\n" # end of HTTP header
echo 

for i in $Args ;do
	IFS="${OIFS}="
	set $i
	IFS="${OIFS}"
	#echo -ne "$1 = $2\n"

	if [ "$1" != "target" && $TARGET -lt 0 ];then
		echo -ne "FAIL TARGET\n"
		exit -1
	fi

	#check or adjust the value of each key
	case $1 in
		target) 
			TARGET=$2
			if [ $TARGET -lt 0 || $TARGET -gt 4 ];then
				echo -ne "FAIL TARGET\n"
				exit -1
			fi
			continue
			;;
		action)
			ACTION="$2"
			if [ $ACTION != "add" && $ACTION != "update" && $ACTION != "remove" ];then
				echo -ne "FAIL ACTION\n"
				exit -1
			fi
			continue
			;;
		name) 
			NAME="${2//%20/ }"
			echo  `confclient -c -p 99 -s "reportpush_protocol_i${TARGET}_name"="${NAME}" | sed 's/=/="/g;s/$/"/g'`
			continue
			;;
		protocol)
			if [ "$2" != "http" && "$2" != "email" && "$2" != "ftp" && "$2" !="sdcard" ];then
				echo -ne "FAIL PROTOCOL\n"
				exit -1
			else
				PROTOCOL="$2"
				ORI_PROTOCOL="`confclient -p 99 -g reportpush_protocol_i${TARGET}_protocol | cut -d '=' -f2`"
			fi
			;;
		schedule|aggregation)
			if [ $2 != 60 && $2 != 300 && $2 != 900 && $2 != 1800 && $2 != 3600 && $2 != 43200 && $2 != 86400 ];then
				echo -ne "FAIL $1\n"
				exit -1
			fi
			;;
		format)
			if [ $2 != xml && $2 != json && $2 != csv ];then
				echo -ne "FAIL FORMAT\n"
				exit -1
			fi
			;;
		lite|localtime|sslmode)
			if [ $2 != 0 && $2 != 1 ];then
				echo -ne "invalid $1\n"
				exit -1
			fi
			;;
		url|port|uri|usr|pwd|sender|recipient|fileformat|sdcyclic) 
			;;
		t)
			continue
			;;
		*)
			echo -ne "Not support column!\n"
			break
			;;
	esac

	# apply change
	echo  `confclient -c -p 99 -s "reportpush_protocol_i${TARGET}_${1}"="${2}" | sed 's/=/="/g;s/$/"/g;s/\\\\/\\\\\\\\/g;'`
done

case "$ACTION" in
	"add")
		mkdir -p ${DEMO_DIR}/${PROTOCOL}/i${TARGET}
		echo `confclient -p 99 -s "reportpush_protocol_i${TARGET}_status"=set | sed 's/=/="/g;s/$/"/g'`
		;;
	"remove")
		PROTOCOL="`confclient -p 99 -g reportpush_protocol_i${TARGET}_protocol | cut -d '=' -f2`"
		reset_target ${TARGET}
		/bin/rm ${DEMO_DIR}/${PROTOCOL}/i${TARGET} -rf
		;;
	"update")
		echo `confclient -p 99 -s "reportpush_protocol_i${TARGET}_status"=set | sed 's/=/="/g;s/$/"/g'`
		if [ -n "${ORI_PROTOCOL}" -a "${ORI_PROTOCOL}" != "${PROTOCOL}" ];then
			mkdir -p ${DEMO_DIR}/${PROTOCOL}/i${TARGET}
			/bin/mv ${DEMO_DIR}/${ORI_PROTOCOL}/i${TARGET}/* ${DEMO_DIR}/${PROTOCOL}/i${TARGET}/
			/bin/rm ${DEMO_DIR}/${ORI_PROTOCOL}/i${TARGET} -rf
		fi
		;;
esac

exit 0
