#!bin/bash

if [ -f "/proc/umap/ive" ]
then
	Platform=`cat /proc/umap/ive | grep Version | awk '{print substr($3,match($3,/Hi/),length($3));}' | cut -d"_" -f1`

	if [ "$Platform" == "Hi3519V101" ]; then
		SDK_Ver="1.0.3.0"
	elif [ "$Platform" == "Hi3516A" ]; then
		SDK_Ver="1.0.7.0"
	fi

	CUR_Ver=`cat /proc/umap/ive | grep Version | awk '{print substr($3,match($3,/_V/)+2,length($3));}' | cut -d"_" -f1`	
	if [ "$(printf '%s\n' "$CUR_Ver" "$SDK_Ver" | sort -t. -n -k1,1 -k2,2 -k3,3 -k4,4 | head -n1)" == "$SDK_Ver" ]; then
		echo "$Platform, greater than or equal to $SDK_Ver"
		return=1
	else
		echo "$Platform, less than $SDK_Ver"
		return=0
	fi
else
	echo "/proc/umap/ive not found."
	return=1
fi
exit $return
