import sys,ure,uos,utime,ujson
class _System():
 __os=uos
 def __init__(self,stdout='/mnt/ramdisk/.vca_syscall'):
  self.result_file=stdout
 def _log(self,msg):
  print(msg)
 def check_file_exist(self,file_path):
  return self.__os.system('[ -e "'+file_path+'" -a ! -d "'+file_path+'" ]')==0
 def check_folder_exist(self,folder_path):
  return self.__os.system('[ -d "'+folder_path+'" ]')==0
 def remove_file(self,file_path):
  try:
   self.__os.remove(file_path)
  except OSError:
   self._log('do not exist or not file path : '+file_path)
   return False
  except:
   self._log('remove : '+file_path+' failed')
   return False
  return True
 def write_file(self,data,file_path):
  tmp_file=file_path+'.bak'
  try:
   with open(tmp_file,'w')as file_data:
    file_data.write(data)
  except:
   self._log('open '+tmp_file+' for '+file_path+' failed')
   return False
  if self.__os.system('mv '+tmp_file+' '+file_path)!=0:
   self._log('overwrite '+file_path+' failed')
   self.remove(tmp_file)
   return False
  self.sync()
  return True
 def write_file_append(self,data,file_path):
  try:
   with open(file_path,'a')as file_data:
    file_data.write(data)
  except:
   self._log('open '+file_path+' for appending failed')
   return False
  self.sync()
  return True
 def sync(self):
  return self.__os.system('sync')==0
 def read_file(self,file_path):
  try:
   with open(file_path,'r')as file_data:
    data=file_data.read()
   return data
  except OSError:
   self._log('file not exist : '+file_path)
  except:
   self._log('open '+file_path+' for reading failed')
  return None
 def copy_replaced_file(self,src,target,replaces=None):
  content=self.read_file(src)
  if content is None:
   self._log("read file {} failure ".format(src))
   return False
  if replaces:
   for s1,s2 in replaces:
    content=content.replace(s1,s2)
  return self.write_file(content,target)
 def exec_shell_cmd(self,cmd,divert_output=''):
  def std_out():
   if self.__os.system(cmd+' > '+self.result_file)!=0:
    return None
   output=self.read_file(self.result_file)
   return output
  def divert_out():
   if self.__os.system(cmd+' > '+divert_output)!=0:
    return None
   return ''
  if divert_output=='':
   output=std_out()
   self.remove_file(self.result_file)
  else:
   output=divert_out()
  if output is None:
   self._log('Exec. shell command ('+cmd+') failed')
   return None
  return output.rstrip('\n')
 def get_pid_by_name(self,name):
  return self.exec_shell_cmd('pgrep '+name)
 def make_folder(self,folder_path):
  if not self.check_folder_exist(folder_path):
   return self.__os.system('mkdir -p '+folder_path)==0
  return True
 def get_file_list(self,folder_path):
  if not self.check_folder_exist(folder_path):
   return None
  return[n[0]for n in list(self.__os.ilistdir(folder_path))if n[1]&0x8000==0x8000]
 def mount_nfs(self,ip,sevr_path,local_path):
  if not self.make_folder(local_path):
   return False
  return self.__os.system('mount -t nfs -o nolock,tcp, '+ip+':/'+sevr_path+' '+local_path)==0
 def umount(self,path):
  return self.__os.system('umount '+path)==0
 def enable_remote_core_dump(self,sevr_ip,sevr_path,mount_path,core_dump_name,size):
  if not self.make_folder(mount_path):
   return False
  self.umount(mount_path)
  if not self.mount_nfs(sevr_ip,sevr_path,mount_path):
   return False
  return self.__set_core_dump('-c '+str(size),mount_path+'/'+core_dump_name)
 def enable_core_dump(self,path,name,size):
  if not self.make_folder(path):
   return False
  return self.__set_core_dump('-c '+str(size),path+'/'+name)
 def __set_core_dump(self,arg,file_path):
  return self.__os.system('ulimit {} ; echo {} > /proc/sys/kernel/core_pattern'.format(arg,file_path))==0
 def start_daemon(self,name,path='',exec_arg='',prog_arg='',pid_file=''):
  if exec_arg:
   exec_arg='-x '+exec_arg
  if prog_arg:
   prog_arg=' -- '+prog_arg
  if pid_file:
   pid_file=' -m -p '+pid_file
  return self.__os.system('start-stop-daemon -S -q -n '+name+pid_file+' -b '+exec_arg+' '+path+prog_arg)==0
 def stop_daemon(self,name,pid_file=''):
  if pid_file:
   pid_file=' -p '+pid_file
  return self.__os.system('start-stop-daemon -K -q -s 15 -n '+name+pid_file)==0
 def get_dirname(self,path):
  return self.exec_shell_cmd('dirname "'+path+'"')
class _VIVOFwSystem():
 def __init__(self,system,logger=None):
  self._system=system
  self.__confclient=self._system.exec_shell_cmd('which confclient')
  self.__tiny_xml_parser=self._system.exec_shell_cmd('which tinyxmlparser')
  self.__fifo_cmd=self._system.exec_shell_cmd('which fifocmd')
  self._logger=logger or _DummyLogger()
 def fw_configer_get(self,path,opt=''):
  return self._system.exec_shell_cmd('{} -g {} -p 99 {}'.format(self.__confclient,path,opt))
 def fw_configer_set(self,path,value):
  return self._system.exec_shell_cmd('{} -s {}={} -p 99'.format(self.__confclient,path,value))!=None
 def fw_configer_restart(self):
  def restart():
   self._logger.info_log('cnofiger restart ...')
   return self._system.exec_shell_cmd('/etc/init.d/configer restart')!=None
  def test_ready(max_retry):
   retry_count=0
   while not self.fw_configer_get('test'):
    retry_count+=1
    if retry_count==max_retry:
     return False
    utime.sleep(1)
   return True
  def check_running():
   if not self._system.check_file_exist('/var/run/configer.pid'):
    return False
   return test_ready(3)
  def safe_restart(max_retry):
   retry_count=0
   ret=restart()
   while not check_running():
    ret=restart()
    retry_count+=1
    if retry_count==max_retry:
     return check_running()
   return ret
  return safe_restart(5)
 def fw_xml_parse_get(self,xml_path,file_path):
  return self._system.exec_shell_cmd('{} -x "{}" -f "{}"'.format(self.__tiny_xml_parser,xml_path,file_path))
 def fw_xml_parse_set(self,data,xml_path,file_path):
  return self._system.exec_shell_cmd('{} -x "{}" -f "{}" -w "{}"'.format(self.__tiny_xml_parser,xml_path,file_path,data))!=None
 def send_tcp_socket_raw_data(self,socket_path,data):
  return self._system.exec_shell_cmd('{} -s "{}" -t -r "{}"'.format(self.__fifo_cmd,socket_path,data))!=None
 def send_fifo_raw_data(self,fifo_path,data):
  return self._system.exec_shell_cmd('{} -p "{}" -r "{}"'.format(self.__fifo_cmd,fifo_path,data))!=None
 def get_fw_di_status(self):
  try:
   di_num=int(self.fw_configer_get('capability_ndi','-t Value'))
  except:
   return[]
  di_status=[]
  for index in range(di_num):
   try:
    di_status.append(int(self._system.exec_shell_cmd('cat /var/run/iod/di{}_status'.format(index))))
   except Exception as e:
    self._logger.error_log('read iod di[{}] status failed : {}'.format(index,e))
    raise e
  return di_status
 def enable_fw_video_metadata(self,analy_tag_val,meta_tag_val,timeout_sec=0):
  onvif_file={'metadata':'/etc/conf.d/config_onvif/config_onvif_metadata.xml','media_profile':'/etc/conf.d/config_onvif/config_onvif_media_profile.xml'}
  def check_file_exist(path):
   return self._system.check_file_exist(path)
  def wait_onvif_cfg_ready(sec):
   while sec>-1:
    metadata_file=check_file_exist(onvif_file['metadata'])
    media_profile=check_file_exist(onvif_file['media_profile'])
    if metadata_file and media_profile:
     return True
    sec-=1
    utime.sleep(1)
   return False
  if not wait_onvif_cfg_ready(timeout_sec):
   self._logger.error_log('firmware onvif config file : [{}, {}] not exist or not ready'.format(onvif_file['metadata'],onvif_file['media_profile']))
   return False
  try:
   cmd='cat '+onvif_file['media_profile']
   cmd+=' | grep "/videoanalyticsconfiguration"'
   cmd+=' | wc -l'
   media_profile_num=int(self._system.exec_shell_cmd(cmd))
  except:
   self._logger.error_log('Convert onvif media profile number failed')
   return False
  if media_profile_num==0:
   self._logger.error_log('firmware not support onvif media profile')
   return False
  for index in range(media_profile_num):
   self.fw_xml_parse_set(analy_tag_val,'/mediaconf/profile/i'+str(index)+'/videoanalyticsconfiguration/token',onvif_file['media_profile'])
   self.fw_xml_parse_set(meta_tag_val,'/mediaconf/profile/i'+str(index)+'/metadataconfiguration/token',onvif_file['media_profile'])
  self.fw_xml_parse_set(analy_tag_val,'/root/metadataconfiguration/AnalyticsEngineConfiguration',onvif_file['metadata'])
  return True
 def fw_evemgr_reload(self):
  self._logger.info_log('event manager reload ...')
  return self._system.exec_shell_cmd('/etc/init.d/eventmgr reload')!=None
 def fw_boa_reload(self):
  self._logger.info_log('boa reload ...')
  return self._system.exec_shell_cmd('kill -31 $(cat /var/run/boa.pid)')!=None
 def fw_onvif_event_reload(self):
  self._logger.info_log('onvifeventd reload')
  return self._system.exec_shell_cmd('/etc/init.d/onvifeventd reload')!=None
 def fw_stereo_lens_calibrate_restart(self):
  self._logger.alarm_log('Not support stereo lens calibration')
  return True
 def install_onvif_proper_evt(self,src_path):
  if not self._system.check_folder_exist(src_path):
   return False
  return self._system.exec_shell_cmd('cp -arf '+src_path+'/* /mnt/ramdisk/event')!=None
 def switch_http_auth(self,mode):
  if not mode=='basic' and not mode=='digest':
   return False
  if not self.fw_configer_set('network_http_authmode',mode):
   return False
  return True
 def switch_rtsp_auth(self,mode):
  if not mode=='basic' and not mode=='digest' and not mode=='disable':
   return False
  if not self.fw_configer_set('network_rtsp_authmode',mode):
   return False
  return True
 def unload_watchdog(self,pid):
  pid=str(pid)
  if not pid.isdigit():
   return False
  real_path=self._system.exec_shell_cmd('realpath /proc/{}/exe'.format(pid))
  if real_path==None:
   return False
  prog_name=self._system.exec_shell_cmd('basename {}'.format(real_path))
  if prog_name==None:
   return False
  socket_path='/var/run/swatchdog/swatchdog.sck'
  data='<control><source name=\\"{}\\">unloadWatchDog</source></control>'.format(prog_name)
  return self._system.exec_shell_cmd('{} -s "{}" -c "{}"'.format(self.__fifo_cmd,socket_path,data))!=None
class SCFwSystem(_VIVOFwSystem):
 def __init__(self,system,logger=None):
  super(SCFwSystem,self).__init__(system,logger=logger)
 def fw_stereo_lens_calibrate_restart(self):
  self._logger.info_log('stereo lens calibration restart')
  stereo_lens_calibrate_path='/etc/init.d/stereolenscalibrate'
  return self._system.exec_shell_cmd(stereo_lens_calibrate_path+' restart')!=None
class _DummyLogger():
 def __init__(self):
  self.error_log=self.__log
  self.alarm_log=self.__log
  self.info_log=self.__log
  self.debug_log=self.__log
 def __log(self,msg):
  print(msg)
class _Logger():
 log_level={'error':0,'alarm':1,'info':2,'debug':3}
 def __new__(cls,log_path='/mnt/ramdisk/.upy_log',level=0,cyclic_size=100,system=None):
  if not system.make_folder(system.get_dirname(log_path)):
   return None
  return object.__new__(cls)
 def __init__(self,log_path='/mnt/ramdisk/.upy_log',level=0,cyclic_size=100,system=None):
  self.__path=log_path
  self.__level=level
  self.__size=cyclic_size
  self._system=system
  self._time=utime
 def error_log(self,msg):
  if self.__level>=self.log_level['error']:
   return self._log(msg)
  return False
 def alarm_log(self,msg):
  if self.__level>=self.log_level['alarm']:
   return self._log(msg)
  return False
 def info_log(self,msg):
  if self.__level>=self.log_level['info']:
   return self._log(msg)
  return False
 def debug_log(self,msg):
  if self.__level>=self.log_level['debug']:
   return self._log(msg)
  return False
 def _log(self,msg,obj=None):
  def compose_time():
   current_time=self._time.localtime()
   return '[{:0>4d}/{:0>2d}/{:0>2d} {:0>2d}:{:0>2d}:{:0>2d}]'.format(current_time[0],current_time[1],current_time[2],current_time[3],current_time[4],current_time[5])
  if not self._system.write_file_append(compose_time()+' '+msg+'\n',self.__path):
   return False
  return self.__cyclic()
 def __cyclic(self):
  return self._system.exec_shell_cmd('while [ $(du -k '+self.__path+' | cut -f1) -gt '+str(self.__size)+' ]; do sed -i \'1d\' '+self.__path+'; sync; done')!=None
class _PkgEvtDIMgr():
 __evt_di_task_file='di_task.xml'
 __fw_evt_task_file='/etc/conf.d/event/task/'+__evt_di_task_file
 def __init__(self,pkg_path,fw,system=None,logger=None):
  self.__pkg_path=pkg_path
  self._fw=fw
  self._system=system or self._fw._system
  self._logger=logger or _DummyLogger()
  self.__evtmgr_reload_sig=False
 def install_evt_di(self):
  di_task_path='{}/conf.d/usrdef/{}'.format(self.__pkg_path,self.__evt_di_task_file)
  replaces=[('/mnt/flash2/vadp-preload/0',self.__pkg_path)]
  if not self._system.copy_replaced_file(di_task_path,self.__fw_evt_task_file,replaces):
   self._logger.error_log('Package event DI task install failed')
   return False
  self.__evtmgr_reload_sig=True
  return True
 def remove_evt_di(self):
  if not self._system.remove_file(self.__fw_evt_task_file):
   self._logger.error_log('Remove DI task from firmware failed')
   return False
  self.__evtmgr_reload_sig=True
  return True
 def get_reload_sig(self):
  return self.__evtmgr_reload_sig
 def clear_reload_sig(self):
  self.__evtmgr_reload_sig=False
class _PkgMvaasMgr():
 __pkg_path=''
 __mvaasd_config='/etc/conf.d/mvaasd.conf'
 __vadp_file='vadp.xml'
 __referer_config='/etc/conf.d/config_referer.xml'
 def __init__(self,pkg_path,fw,system=None):
  self.__pkg_path=pkg_path
  self._fw=fw
  self._system=system or self._fw._system
 def modify_mvaasconf(self):
  file_data=self._system.read_file(self.__mvaasd_config)
  if file_data is None:
   return False
  file_data=file_data.replace('HTTPExtraInfoUrl /cgi-bin/viewer/getparam.cgi?system_hostname&system_location_groupid&system_location_deviceid','HTTPExtraInfoUrl '+self.__get_vadp_link_name()+'/cgi-bin/get_mvaas_param.cgi')
  return self._system.write_file(file_data,self.__mvaasd_config)
 def clear_mvaas_referer(self):
  file_data=self._system.read_file(self.__referer_config)
  if file_data is None:
   return False
  if file_data.find(self.__get_mvaas_reg_address())<0:
   return True
  file_data=file_data.replace(self.__get_mvaas_reg_address(),'')
  if not self._system.write_file(file_data,self.__referer_config):
   return False
  return self._fw.fw_boa_reload()
 def __get_vadp_link_name(self):
  return self._fw.fw_xml_parse_get('/vadp/name',self.__pkg_path+'/'+self.__vadp_file).replace(' ','-')
 def __get_mvaas_reg_address(self):
  return self._fw.fw_configer_get('system_mvaas_registerserver_address','-t Value')
class _PkgReportPushMgr():
 __evt_report_push_task='report_task.xml'
 __fw_evt_report_push_task='/etc/conf.d/event/task/'+__evt_report_push_task
 __config_file='config_reportpush.xml'
 def __init__(self,pkg_path,fw,system=None,logger=None):
  self.__pkg_path=pkg_path
  self._fw=fw
  self._system=system or self._fw._system
  self._logger=logger or _DummyLogger()
  self.__update_script=self.__pkg_path+'/scripts/updateReport'
  self.__evtmgr_reload_sig=False
  self.__cfger_reload_sig=False
 def install_report_push(self):
  def install_evt_task():
   src_file='{}/conf.d/default/{}'.format(self.__pkg_path,self.__evt_report_push_task)
   replaces=[('/usr/bin',self.__pkg_path+'/cgi-bin')]
   if not self._system.copy_replaced_file(src_file,self.__fw_evt_report_push_task,replaces):
    self._logger.error_log('Install event report push task failed')
    return False
   return True
  def clear_sqlite_cmd():
   self._system.exec_shell_cmd('rm -f /mnt/flash2/reportpush/*.sql')
   return True
  def copy_stunnel():
   conf='https_client.conf'
   src='{}/conf.d/default/{}'.format(self.__pkg_path,conf)
   dst='{}/conf.d/usrdef/{}'.format(self.__pkg_path,conf)
   if self._system.exec_shell_cmd('cp {} {}'.format(src,dst))==None:
    self._logger.error_log('Install stunnel failed')
    return False
   return True
  if any([not install_evt_task(),not clear_sqlite_cmd(),not copy_stunnel()]):
   self._logger.error_log('Install related config failed')
   return False
  self.__evtmgr_reload_sig=True
  return True
 def remove_report_push(self):
  def remove_task():
   if not self._system.remove_file(self.__fw_evt_report_push_task):
    self._logger.error_log('Remove event reprot push task failed')
    return False
   return True
  def remove_backup():
   if self._system.exec_shell_cmd(self.__update_script+' deleteAll')==None:
    self._logger.error_log('Remove report push backup failed')
    return False
   return True
  if any([not remove_task(),not remove_backup()]):
   self._logger.error_log('Remove report push failed')
   return False
  self.__evtmgr_reload_sig=True
  return True
 def upgrade_report_push(self,upgrade_pkg_path):
  usr_cfg_path='/conf.d/usrdef/'
  src_cfg=self.__pkg_path+usr_cfg_path+self.__config_file
  dst_cfg=upgrade_pkg_path+usr_cfg_path+self.__config_file
  def check_transfer_config():
   if self._system.check_file_exist(src_cfg):
    return True
   return False
  def keep_config():
   if self._system.exec_shell_cmd('cp {} {}'.format(src_cfg,dst_cfg))==None:
    self._logger.error_log('Keep old config failed')
    return False
   return True
  def convert_backup():
   if self._system.exec_shell_cmd(self.__update_script+' checkBackup')==None:
    self._logger.error_log('Convert backup file failed')
    return False
   return True
  def remove_cdf():
   cdf='/etc/conf.d/CDF/CDF_reportpush.xml'
   if not self._system.check_file_exist(cdf):
    self._logger.alarm_log('Clear FW without report push CDF')
    return True
   if not self._system.remove_file(cdf):
    self._logger.error_log('Remove report push CDF from firmware')
    return False
   self.__cfger_reload_sig=True
   return True
  if not check_transfer_config():
   self._logger.alarm_log('Skip transferring config from firmware CDF')
   return True
  if any([not keep_config(),not convert_backup(),not remove_cdf()]):
   self._logger.error_log('Transfer related file failed')
   return False
  return True
 def restore_report_push(self):
  return self._system.exec_shell_cmd(self.__update_script+' deleteAll')!=None
 def get_evt_reload_sig(self):
  return self.__evtmgr_reload_sig
 def clear_evt_reload_sig(self):
  self.__evtmgr_reload_sig=False
 def get_cfger_reload_sig(self):
  return self.__cfger_reload_sig
 def clear_cfger_reload_sig(self):
  self.__cfger_reload_sig=False
class _PkgValidationMgr():
 def __init__(self,pkg_path,system):
  self.__script_path=pkg_path+'/scripts/validation.sh'
  self._system=system
 """
    @ret : bool : success or not
    """ 
 def auto_validation(self):
  return self._system.exec_shell_cmd(self.__script_path+' auto')!=None
 """
    @ret : bool : success or not
    """ 
 def stop_validation(self):
  return self._system.exec_shell_cmd(self.__script_path+' stop')!=None
class AppMonitor():
 def __init__(self,system,logger=None):
  self._system=system
  self._logger=logger or _DummyLogger()
  self._monitor_app_list=[]
 def add_app(self,app_name,exec_args='',prog_arg=''):
  self._monitor_app_list.append((app_name,exec_args,prog_arg))
  return True
 def start_apps(self):
  ret=True
  for name,exec_args,prog_args in self._monitor_app_list:
   if not self._system.start_daemon(name,exec_arg=exec_args,prog_arg=prog_args):
    self._logger.error_log('Start app {} with exec_arg="{}" with prog_arg="{}" failed'.format(name,exec_args,prog_args))
    ret=False
  return ret
 def stop_apps(self):
  for app_info in self._monitor_app_list:
   name=app_info[0]
   if not self._system.stop_daemon(name):
    self._logger.error_log('Stop app {} failure'.format(name))
  return True
 def stop_apps_force(self):
  for app_info in self._monitor_app_list:
   name=app_info[0]
   self._system.exec_shell_cmd('pkill -9 {}'.format(name))
 def is_all_running(self):
  pids=[self._system.get_pid_by_name(app[0])for app in self._monitor_app_list]
  return(len(pids)>0)and all(pids)
 def is_any_running(self):
  pids=[self._system.get_pid_by_name(app[0])for app in self._monitor_app_list]
  return(len(pids)>0)and any(pids)
 def wait_for_all_running(self,max_trial=5):
  return self.__wait_for_state(self.is_all_running,True,max_trial)
 def wait_for_all_stopping(self,max_trial=5):
  return self.__wait_for_state(self.is_any_running,False,max_trial)
 def __wait_for_state(self,check_func,state,max_trial):
  trial=0
  while check_func()!=state:
   utime.sleep(1)
   trial+=1
   if trial>=max_trial:
    break
  return check_func()==state
class _DummpyDefaultOffMgr():
 def __init__(self):
  pass
 def is_pkg_default_run(self):
  return True
 def is_pkg_never_started(self):
  return False
 def set_default_off_flag(self):
  return False
 def clear_default_off_flag(self):
  return False
class _PkgDefaultOffMgr():
 __config='/etc/vca/vca.json'
 __pkg_default_run=False
 def __init__(self,pkg_path,modelname,sys,logger=None):
  self._sys=sys
  self._logger=logger or _DummyLogger()
  self.__modelname=modelname
  self.__flag_filepath='{}/pkg_default_off'.format(pkg_path)
  models=self.__get_default_off_model_list()
  self.__pkg_default_run=not((modelname in models)or('MS9390' in modelname))
 def is_pkg_default_run(self):
  return self.__pkg_default_run
 def is_pkg_never_started(self):
  return not(self.is_pkg_default_run()or self._sys.check_file_exist(self.__flag_filepath))
 def set_default_off_flag(self):
  if not self.is_pkg_default_run():
   if self._sys.write_file_append('',self.__flag_filepath)==True:
    return True
   self._logger.error_log('cannot touch {} !!'.format(self.__flag_filepath))
  return False
 def clear_default_off_flag(self):
  return self._sys.remove_file(self.__flag_filepath)
 def __get_default_off_model_list(self):
  key='VcaPkgDefaultOff'
  try:
   with open(self.__config)as fw_vca_config:
    json_config=ujson.load(fw_vca_config)
    if key in json_config and type(json_config[key])is list:
     return json_config[key]
    self._logger.info_log('{}[{}] is not a list'.format(self.__config,key))
  except Exception as e:
   self._logger.info_log('get {} model list from {} failure : {}'.format(key,self.__config,e))
  return[]
import utime
class TrackerSocketCmd():
 def __init__(self,modelname,fw,logger=None):
  self._fw=fw
  self._logger=logger or _DummyLogger()
  self.__socket_path=self.__get_tracker_socket_path(modelname)
  self.__fifo_path='/var/run/trackerfifo'
 def reload(self):
  if not self.__retry_until_response(self._fw.send_tcp_socket_raw_data,self.__socket_path,chr(0x1f)):
   self._logger.error_log('Send TCP reload cmd to {} failed'.format(self.__socket_path))
   return False
  return True
 def notify_di0_status(self,triggered):
  cmd=chr(0x29)if triggered else chr(0x2A)
  if not self.__retry_until_response(self._fw.send_tcp_socket_raw_data,self.__socket_path,cmd):
   self._logger.error_log('Noitfy di status fail due to {} not ready'.format(self.__socket_path))
   return False
  return True
 def notify_metadata_record(self):
  if not self.__retry_until_response(self._fw.send_fifo_raw_data,self.__fifo_path,chr(0x2d)):
   self._logger.error_log('Send FIFO cmd to {} to notify metadata video record failed'.format(self.__fifo_path))
   return False
  return True
 def __retry_until_response(self,func,path,cmd):
  for retry in range(5):
   if func(path,cmd):
    return True
   utime.sleep(1)
  return func(path,cmd)
 def __get_tracker_socket_path(self,model):
  socket='trackersck'
  if model and len(model)>2 and model[:2]in('SC','AT'):
   socket='stereotrackersck'
  return '/var/run/'+socket
class _SuppoetExcept(Exception):
 def __init__(self,support):
  self.support=support
 def __str__(self):
  return 'The firmware not support exception due to {}'.format(self.support)
class _CmdExcept(Exception):
 def __init__(self,cmd):
  self.cmd=cmd
 def __str__(self):
  return 'Command: "{}" exception'.format(self.cmd)
class PkgCmder():
 __pkg_path=''
 __upgrade_pkg_path=''
 __log_path='/logs'
 __vadp_ver='no vadp version'
 def __init__(self,pkg_path,upgrade_pkg_path,installer,processor,fw,system=None,logger=None):
  def get_vadp_ver():
   vadp_ver=self._fw.fw_configer_get('vadp_version','-t Value')
   if vadp_ver is None:
    self._logger.error_log('The firmware not support "configer"')
    raise _SuppoetExcept('configer')
   elif vadp_ver=='':
    self._logger.error_log('The firmware not support "VADP"')
    raise _SuppoetExcept('VADP')
   self._logger.info_log('Using VADP version : '+vadp_ver)
   return vadp_ver
  self.__pkg_path=pkg_path
  self.__upgrade_pkg_path=upgrade_pkg_path
  self._fw=fw
  self._system=system or self._fw._system
  self._installer=installer
  self._processor=processor
  self._logger=logger or _DummpyLogger()
  self.__log_path=self.__pkg_path+self.__log_path
  self.__vadp_ver=get_vadp_ver()
  self.cmd_map={'install':self._installer.install,'remove':self._installer.remove,'upgrade':self._installer.upgrade,'prerestore':self._installer.prerestore,'restore':self._installer.restore,'start':self._processor.start,'stop':self._processor.stop,'reload':self._processor.reload}
  self._logger.debug_log('PkgCmder init. done')
 def exec_pkg_cmd(self,cmd):
  if cmd not in self.cmd_map:
   self._logger.error_log('ExecCmd : Unrecognized cmd : {}'.format(cmd))
   raise _CmdExcept(cmd)
  self._logger.info_log('ExecCmd : {}, Package Path : {}, Upgrade Package Path : {}'.format(cmd,self.__pkg_path,self.__upgrade_pkg_path))
  if not self.cmd_map[cmd]():
   self._logger.error_log('ExecCmd : {} failed'.format(cmd))
   raise _CmdExcept(cmd)
  return True
import ure
class _PkgInstaller():
 __vca_function_config='config_vca_functions.json'
 def __init__(self,pkg_path,upgrade_pkg_path,modelname,evt_di_mgr,report_push_mgr,fw,system=None,logger=None,default_off=None):
  self.__pkg_path=pkg_path
  self.__upgrade_pkg_path=upgrade_pkg_path
  self.__modelname=modelname
  self._evt_di_mgr=evt_di_mgr
  self._report_push_mgr=report_push_mgr
  self._fw=fw
  self._system=system or self._fw._system
  self._logger=logger or _DummyLogger()
  self._default_off_mgr=default_off or _DummpyDefaultOffMgr()
  self.__re=ure
  self._logger.debug_log('Instaler init. done')
 def install(self):
  def record_pkg_path():
   record_path='/mnt/flash2/tracker_package_path'
   if not self._system.write_file(self.__pkg_path,record_path):
    self._logger.error_log('Record package to ({}) failed'.format(record_path))
    return False
   return True
  if any([not self.__check_platform(self.__pkg_path),not self.__check_brand(self.__pkg_path),not self._evt_di_mgr.install_evt_di(),not self._report_push_mgr.install_report_push(),not self.__set_tampering_capablity(),not record_pkg_path(),not self.__reload_fw_daemon()]):
   return False
  return True
 def remove(self):
  def remove_evt_trigger():
   def get_trigger_max_num():
    return self._fw.fw_configer_get('vadp_event_ntrigger','-t Value')
   try:
    for index in range(int(get_trigger_max_num())):
     topic_name_path='vadp_event_triggerlist_i{}_topic'.format(index)
     topic_name=self._fw.fw_configer_get(topic_name_path,'-t Value')
     if topic_name.find('tns1:RuleEngine/TrackerAlarm/')!=0:
      continue
     if not self._fw.fw_configer_set(topic_name_path,''):
      self._logger.error_log('Remove event trigger failed : '+topic_name)
      return False
   except:
    self._logger.error_log('Can not get max vadp event trigger list num')
    return False
   return True
  ret=(remove_evt_trigger()and self._evt_di_mgr.remove_evt_di()and self._report_push_mgr.remove_report_push()and self.__reload_fw_daemon())
  return ret
 def upgrade(self):
  def upgrade_onvif_config():
   configer=self._system.exec_shell_cmd('which onvifcfg_configer')
   if configer==None:
    self._logger.alarm_log('Skip upgrade onvif config')
    return True
   usr_cfg_path='/conf.d/usrdef/'
   pkg_cfg_path=self.__pkg_path+usr_cfg_path
   upgrade_cfg_path=self.__upgrade_pkg_path+usr_cfg_path
   cmd='{} -b {} -n {}'.format(configer,pkg_cfg_path,upgrade_cfg_path)
   if self._system.exec_shell_cmd(cmd)==None:
    self._logger.error_log('upgrade onvif config failed')
    return False
   return True
  def keep_vca_config():
   old_config_path=self.__pkg_path+'/conf.d/vca/'
   upgrade_config_path=self.__upgrade_pkg_path+'/conf.d/vca/'
   old_vca_func_file='{}{}'.format(old_config_path,self.__vca_function_config)
   def check_old_vca_func():
    return self._system.check_file_exist(old_vca_func_file)
   def remove_vca_func():
    if check_old_vca_func():
     if not self._system.remove_file(old_vca_func_file):
      self._logger.error_log('Can NOT remove vca function')
      return False
    return True
   def migrate_vca():
    if not self._system.make_folder(upgrade_config_path):
     self._logger.error_log('Can not create vca folder for migrating old vca config')
     return False
    cmd='cp -arf {}* {}'.format(old_config_path,upgrade_config_path)
    if self._system.exec_shell_cmd(cmd)==None:
     self._logger.error_log('Migrate vca config falied')
     return False
    return True
   if not self._system.check_folder_exist(old_config_path):
    self._logger.alarm_log('No any vca config to upgrade, skip it')
    return True
   if any([not remove_vca_func(),not migrate_vca()]):
    self._logger.error_log('Keep VCA config failed')
    return False
   return True
  def keep_logs():
   cmd='cp -arf {}/logs {}'.format(self.__pkg_path,self.__upgrade_pkg_path)
   if self._system.exec_shell_cmd(cmd)==None:
    self._logger.error_log('Keep logs failed')
    return False
   return True
  def install_upgrade():
   def remove_old():
    if self._system.exec_shell_cmd('rm -rf '+self.__pkg_path)==None:
     self._logger.error_log('Remove old version package failed')
     return False
    return True
   def install_new():
    if self._system.exec_shell_cmd('mv {} {}'.format(self.__upgrade_pkg_path,self.__pkg_path))==None:
     self._logger.error_log('install to orig. package failed')
     return False
    return True
   if any([not remove_old(),not install_new()]):
    self._logger.error_log('Upgrade package failed')
    return False
   return True
  def set_default_run_off():
   if not self._default_off_mgr.is_pkg_default_run():
    self._logger.info_log('Upgrade to default run off firmware')
    if not self._default_off_mgr.set_default_off_flag():
     return False
   return True
  if self.__pkg_path==self.__upgrade_pkg_path:
   self._logger.error_log('Can not upgrade by itself')
   return False
  if any([not self.__check_platform(self.__upgrade_pkg_path),not self.__check_brand(self.__upgrade_pkg_path),not set_default_run_off(),not upgrade_onvif_config(),not self._report_push_mgr.upgrade_report_push(self.__upgrade_pkg_path),not keep_vca_config(),not keep_logs(),not self.__set_tampering_capablity(),not self.__reload_fw_daemon(),not install_upgrade()]):
   return False
  return True
 def prerestore(self):
  pass
 def restore(self):
  vca_cfg_path=self.__pkg_path+'/conf.d/vca'
  usr_cfg_path=self.__pkg_path+'/conf.d/usrdef'
  default_cfg_path=self.__pkg_path+'/conf.d/default'
  def clear_usr_config():
   if self._system.exec_shell_cmd('rm -f {}/*'.format(vca_cfg_path))==None:
    self._logger.error_log('Clear usr config failed')
    return False
   return True
  def restore_onvif_config():
   if self._system.exec_shell_cmd('cp {}/config_onvif_*.xml {}'.format(default_cfg_path,usr_cfg_path))==None:
    self._logger.error_log('Restore onvif config failed')
    return False
   return True
  if not self.__update_default_run_off():
   self._logger.error_log('Update default run off flag file failed')
   return False
  if any([not clear_usr_config(),not restore_onvif_config(),not self._report_push_mgr.restore_report_push()]):
   return False
  return True
 def __check_platform(self,pkg_path):
  platform_file='/info/pkg_platform'
  platform_info=[['VATICS Pesaro SoC','rossini'],['Ambarella AMS5L','ams5l'],['Ambarella','ams2l'],['hi3516a','hi3516'],['Hi3519','hi3519'],['Hi3516cv300','hi3516cv300'],['ti8148evm','dm8127']]
  def get_cpu_info():
   return[self._system.exec_shell_cmd('cat /proc/cpuinfo | grep Hardware'),self._system.exec_shell_cmd('cat /proc/device-tree/model')]
  def get_fw_platform(cpu_info):
   for cpu in cpu_info:
    if cpu==None:
     continue
    for platform in platform_info:
     if self.__re.search(platform[0],cpu)!=None:
      return platform[1]
   return 'Unknown'
  def get_pkg_platform():
   return self._system.exec_shell_cmd('cat '+pkg_path+platform_file)
  fw_platform=get_fw_platform(get_cpu_info())
  pkg_platform=get_pkg_platform()
  if fw_platform!=pkg_platform:
   self._logger.error_log('Firmware({}) and package({}) platform not match'.format(fw_platform,pkg_platform))
   return False
  return True
 def __check_brand(self,pkg_path):
  brand_file='/info/pkg_brand'
  def get_fw_brand():
   fw_version=self._fw.fw_configer_get('system_info_firmwareversion','-t Value')
   if fw_version.split('-')[1]=='VVTK':
    return 'obm'
   return 'odm'
  def get_pkg_brand():
   return self._system.exec_shell_cmd('cat '+pkg_path+brand_file)
  fw_brand=get_fw_brand()
  pkg_brand=get_pkg_brand()
  if fw_brand!=pkg_brand:
   self._logger.error_log('Firmware({}) and package({}) brand not match'.format(fw_brand,pkg_brand))
   return False
  return True
 def __set_tampering_capablity(self):
  if self.__modelname.find('SC')==0 or self.__modelname.find('AT')==0:
   if not self._fw.fw_configer_set('capability_tampering',1):
    self._logger.error_log('Setting tampering capability failed')
    return False
  return True
 def __reload_fw_daemon(self):
  def reload_evtmgr():
   if not self._fw.fw_evemgr_reload():
    self._logger.error_log('Reload firmware event mgr failed')
    return False
   self._evt_di_mgr.clear_reload_sig()
   self._report_push_mgr.clear_evt_reload_sig()
   return True
  def restart_cfger():
   if not self._fw.fw_configer_restart():
    self._logger.error_log('Restart firmware configer failed')
    return False
   self._report_push_mgr.clear_cfger_reload_sig()
   return True
  if any([self._evt_di_mgr.get_reload_sig(),self._report_push_mgr.get_evt_reload_sig()]):
   if not reload_evtmgr():
    return False
  if self._report_push_mgr.get_cfger_reload_sig():
   if not restart_cfger():
    return False
  return True
 def __update_default_run_off(self):
  if self._default_off_mgr.is_pkg_default_run():
   return True
  pkg_idx=self._system.exec_shell_cmd('basename {}'.format(self.__pkg_path))
  vadp_order=self._fw.fw_configer_get('vadp_module_order','-t Value').split(',')
  try:
   vadp_order.index(pkg_idx)
   if not self._default_off_mgr.clear_default_off_flag():
    return False
  except:
   if not self._default_off_mgr.set_default_off_flag():
    return False
  return True
import utime
class _PkgProcessor():
 __pkg_path=''
 __tracker_name='tracker_app'
 __database_name='backup_db_app'
 def __init__(self,pkg_path,modelname,validate_mgr,app_monitor,trackersckcmd,fw,system=None,logger=None,default_off=None):
  self.__pkg_path=pkg_path
  self.__modelname=modelname
  self._val_mgr=validate_mgr
  self._app_monitor=app_monitor
  self.__trackersckcmd=trackersckcmd
  self._fw=fw
  self._system=system or self._fw._system
  self._logger=logger or _DummyLogger()
  self._default_off_mgr=default_off or _DummpyDefaultOffMgr()
  self._app_monitor.add_app(self.__tracker_name,self.__get_start_tracker_args())
  database_prog='{}/{}'.format(self.__pkg_path,self.__database_name)
  if self._system.check_file_exist(database_prog):
   self._app_monitor.add_app(self.__database_name,database_prog)
  else:
   self._logger.alarm_log('Database prog not exist, processor without it when init.')
 def start(self):
  def record_ws_ver():
   ver_log='/mnt/flash2/logs/AuthWebsocketVer.log'
   ws_prog=self._system.exec_shell_cmd('which websocketserver')
   ws_ver=''
   if not ws_prog:
    self._logger.alarm_log('The firmware not support websocket server')
   else:
    ws_ver=self._system.exec_shell_cmd('{} -h | grep Version | cut -f 2 -d :'.format(ws_prog)).strip()
   if not self._system.write_file(ws_ver,ver_log):
    self._logger.error_log('Record websocket server version failed')
    return False
   return True
  def check_remote_debug_mode():
   return self._system.check_folder_exist(self.__pkg_path+'/debug')
  if self.__default_run_off():
   return False
  if self._app_monitor.is_any_running():
   self._logger.error_log('backup_db_app or tracker_app is still running')
   self.stop()
   return False
  self.__export_lib_path()
  self._app_monitor.start_apps()
  if not self._app_monitor.wait_for_all_running():
   self._logger.error_log('Start all apps failed')
   self.stop()
   return False
  self._val_mgr.auto_validation()
  record_ws_ver()
  self.__create_ssmux_link()
  self.__mapping_web_layout()
  self.__set_onvif_event()
  self.__install_onvif_proper_evt()
  self.__enable_fw_metadata_stream()
  self._fw.fw_stereo_lens_calibrate_restart()
  self.__load_di_status()
  self.__notify_metadata_record()
  if check_remote_debug_mode():
   self.__set_remote_core_dump()
  else:
   self.__set_local_core_dump()
  return True
 def stop(self):
  self._val_mgr.stop_validation()
  self._app_monitor.stop_apps()
  if not self._app_monitor.wait_for_all_stopping(30):
   self._logger.error_log('Apps. Hanging, Could Not Stop Well! and Force Stopping')
   self._fw.unload_watchdog(self._system.get_pid_by_name(self.__tracker_name))
   self._fw.unload_watchdog(self._system.get_pid_by_name(self.__database_name))
   self._app_monitor.stop_apps_force()
  self.__set_vadp_status('off')
  return True
 def reload(self):
  if any([not self.__set_onvif_event(),not self.__load_di_status(),not self.__trackersckcmd.reload(),not self._val_mgr.auto_validation()]):
   self._logger.error_log('execute reload failed')
   return False
  return True
 def __set_vadp_status(self,status):
  index=self.__pkg_path[-1]
  return self._fw.fw_configer_set('vadp_module_i{}_status'.format(index),status)
 def __set_remote_core_dump(self):
  info_path=self.__pkg_path+'/info'
  platform_file=info_path+'/pkg_platform'
  git_sha_file=info_path+'/git_sha'
  remote_info={'ip':'172.20.2.10','dst_path':'/Share/coredump','mount_path':'/mnt/flash2/coredump/','size':'unlimited'}
  def get_pkg_platform():
   return self._system.exec_shell_cmd('cat '+platform_file)or ''
  def get_system_ip():
   return self._fw.fw_configer_get('network_ipaddress','-t Value')or ''
  def get_pkg_git_sha():
   return self._system.exec_shell_cmd('cat '+git_sha_file)or ''
  file_pattern='core-{}-{}-{}-%e'.format(get_system_ip(),get_pkg_git_sha(),get_pkg_platform())
  if not self._system.enable_remote_core_dump(remote_info['ip'],remote_info['dst_path'],remote_info['mount_path'],file_pattern,remote_info['size']):
   self._logger.error_log('Enable remote server for coredump failed')
   return False
  self._system.write_file(file_pattern,self.__pkg_path+"/info/corefile_prefix")
  return True
 def __set_local_core_dump(self):
  if len(self.__modelname)>2 and self.__modelname[:2]in('SC','AT'):
   core_size='8192'
  else:
   core_size='4096'
  if not self._system.enable_core_dump('/mnt/flash2','core.%e',core_size):
   self._logger.error_log('Enable local core dump failed')
   return False
  return True
 def __enable_fw_metadata_stream(self):
  if len(self.__modelname)>=2 and self.__modelname[:2]in['SC','AT']:
   self._logger.alarm_log('Firmware SC or AT series alredy enable metadata stream, so not enable again')
   return True
  if not self._fw.enable_fw_video_metadata('VVTK_STRACKER','metadata1',timeout_sec=90):
   self._logger.error_log('Enable firmware metadata stream failed')
   return False
  return True
 def __create_ssmux_link(self):
  def gen_link(src):
   target=self.__pkg_path+'/www/ssmux.js'
   self._system.remove_file(target)
   return self._system.exec_shell_cmd('ln -s {} {}'.format(src,target))
  for ver in['1.1.1.0','1.0.0.7']:
   fw_ssumx_file='/www/include/ssmux-{}.js'.format(ver)
   if self._system.check_file_exist(fw_ssumx_file):
    if gen_link(fw_ssumx_file)is None:
     self._logger.error_log('Create ssmux link failed')
     return False
    return True
  self._logger.alarm_log('Can not found any ssumx library from firmware')
  return True
 def __mapping_web_layout(self):
  def gen_link(model):
   target=self.__pkg_path+'/www/layout.xml'
   self._system.remove_file(target)
   source='{}/www/layout_{}.xml'.format(self.__pkg_path,model)
   return self._system.exec_shell_cmd('ln -s {} {}'.format(source,target))
  model_mapping={'8131':'SC8131','8132':'SC8132','8133':'SC8133'}
  for key,model in model_mapping.items():
   if key in self.__modelname:
    if gen_link(model)is None:
     self._logger.error_log('Create web layout link by model ({}) failed'.format(self.__modelname))
     return False
  return True
 def __get_start_tracker_args(self):
  def get_cpu_name():
   return self._system.exec_shell_cmd('cat /proc/umap/ive | grep Version | awk \'{print substr($3,match($3,/Hi/),length($3));}\' | cut -d"_" -f1')
  cpu_name=get_cpu_name()
  prog='{}/{}'.format(self.__pkg_path,self.__tracker_name)
  if cpu_name=="Hi3519V101":
   prog='taskset 0x02 '+prog
  elif cpu_name!='Hi3516A':
   prog=prog+' '+self.__pkg_path
  return prog
 def __install_onvif_proper_evt(self):
  evt_path=self.__pkg_path+'/conf.d/default/PEvent'
  if not self._system.check_folder_exist(evt_path):
   self._logger.alarm_log('Not suppor onvif proper event')
   return True
  if not self._fw.install_onvif_proper_evt(evt_path):
   self._logger.error_log('Install onvif proper event failed')
   return False
  return True
 def __notify_metadata_record(self):
  i0_en=(self._fw.fw_configer_get('recording_i0_enable','-t Value')=='1')
  if not i0_en:
   self._logger.info_log('First recording task not enable, skip notify metadata record')
   return True
  return self.__trackersckcmd.notify_metadata_record()
 def __load_di_status(self):
  try:
   di_status=self._fw.get_fw_di_status()
  except:
   self._logger.error_log('load di status exception')
   return False
  if len(di_status)==0:
   self._logger.alarm_log('Firmware not suuport DI')
   return True
  return self.__trackersckcmd.notify_di0_status(di_status[0]==1)
 def __set_onvif_event(self):
  evt_desc_prog=self.__pkg_path+'/cgi-bin/genEventDesc.cgi'
  if not self._system.check_file_exist(evt_desc_prog):
   self._logger.alarm_log('Not support Onvif event')
   return True
  onvif_re_file=self.__pkg_path+'/conf.d/usrdef/config_onvif_re.xml'
  onvif_re_desc_file=self.__pkg_path+'/conf.d/default/config_event_description.xml'
  if any([None is self._system.exec_shell_cmd('{} -r {} -o {}'.format(evt_desc_prog,onvif_re_file,onvif_re_desc_file)),not self._fw.fw_onvif_event_reload()]):
   self._logger.error_log('set Onvif event failed')
   return False
  return True
 def __export_lib_path(self):
  pkg_ld_config=self.__pkg_path+'/bin/ldconfig'
  pkg_lib_path=self.__pkg_path+'/lib'
  if self._system.check_folder_exist(pkg_lib_path)and self._system.check_file_exist(pkg_ld_config):
   self._logger.info_log('Export Internel library ...')
   if self._system.exec_shell_cmd('{} -C "/etc/ld.so.cache" -n {}'.format(pkg_ld_config,pkg_lib_path))is None:
    self._logger.error_log('Export internal library failed')
    return False
  else:
   self._logger.alarm_log('No internal library or ldconfig not exist, skip export internal library')
  return True
 def __default_run_off(self):
  def update_vadp_order():
   pkg_idx=self._system.exec_shell_cmd('basename {}'.format(self.__pkg_path))
   vadp_order=self._fw.fw_configer_get('vadp_module_order').split('=')
   vadp_order[1]=vadp_order[1].split(',')
   try:
    order_idx=vadp_order[1].index(pkg_idx)
    del vadp_order[1][order_idx]
   except:
    self._logger.error_log('Delete vadp order index : {}, failed'.format(pkg_idx))
    return False
   vadp_order[1]=','.join(vadp_order[1])
   if not self._fw.fw_configer_set(vadp_order[0],vadp_order[1]):
    self._logger.error_log('Set {} to configer failed'.format('='.join(vadp_order[0],vadp_order[1])))
    return False
   return True
  if any([self._default_off_mgr.is_pkg_default_run(),not self._default_off_mgr.is_pkg_never_started()]):
   return False
  self._logger.info_log('Package process default run off and Skip this start command')
  if not self._default_off_mgr.set_default_off_flag():
   return False
  return update_vadp_order()
def main(cmd,pkg_path,upgrade_pkg_path,platform='',features=[],debug=0):
 system=_System()
 logger=_Logger(log_path=pkg_path+'/logs/pkg_main.log',level=_Logger.log_level['info'],system=system)
 if logger is None:
  logger=_DummyLogger()
 fw=_VIVOFwSystem(system,logger=logger)
 modelname=fw.fw_configer_get('system_info_modelname','-t Value')or ''
 if modelname.find('SC')==0 or modelname.find('AT')==0:
  fw=SCFwSystem(system,logger=logger)
 default_off_mgr=_PkgDefaultOffMgr(pkg_path,modelname,system,logger)
 def create_installer():
  return _PkgInstaller(pkg_path,upgrade_pkg_path,modelname,_PkgEvtDIMgr(pkg_path,fw,system=system,logger=logger),_PkgReportPushMgr(pkg_path,fw,system=system,logger=logger),fw,system=system,logger=logger,default_off=default_off_mgr)
 def create_processor():
  return _PkgProcessor(pkg_path,modelname,_PkgValidationMgr(pkg_path,system),AppMonitor(system,logger=logger),TrackerSocketCmd(modelname,fw,logger=logger),fw,system=system,logger=logger,default_off=default_off_mgr)
 pkg_cmder=PkgCmder(pkg_path,upgrade_pkg_path,create_installer(),create_processor(),fw,system=system,logger=logger)
 return pkg_cmder.exec_pkg_cmd(cmd)
if __name__=="__main__":
 if not main(sys.argv[1],sys.argv[2],sys.argv[3],platform='',features=[],debug=0):system.exit(-1)
 sys.exit(0)
# Created by pyminifier (https://github.com/liftoff/pyminifier)

