#!/bin/sh

# System
cmd="${1}"
pkgpath="${2}"
new_package="${3}" # It's new installation package path, we need handle upgrade processing to this path if support upgrade feature

if [ "${cmd}" == "upgrade" ]; then
    execPkg="${new_package}"
else
    execPkg="${pkgpath}"
fi

LOG_PATH="/mnt/flash2/logs"
[ ! -d "${LOG_PATH}" ] && mkdir -p "${LOG_PATH}"

LOG_FILE="${LOG_PATH}/initScript.log"

max_log_size=1000000
touch $LOG_FILE
log_size=$(wc -c <$LOG_FILE)
if [ $log_size -gt $max_log_size ]; then
	rm $LOG_FILE
fi
echo "`date +"%Y-%m-%d %T"` : ${cmd},${pkgpath},${new_package},${execPkg}" >> ${LOG_FILE}
microPython="${execPkg}/bin/micropython"
mainScript="${execPkg}/main.py"
"${microPython}" "${mainScript}" "${cmd}" "${pkgpath}" "${new_package}"

exit $?
